/* guile-irrlicht --- GNU Guile bindings for Irrlicht Engine

   Copyright (C) 2020 Javier Sancho <jsf@jsancho.org>

   This file is part of guile-irrlicht.

   guile-irrlicht is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 3 of the
   License, or (at your option) any later version.

   guile-irrlicht is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with guile-irrlicht. If not, see
   <http://www.gnu.org/licenses/>.
*/

#include <irrlicht/irrlicht.h>
#include <libguile.h>
#include "gui-listbox.h"
#include "gsubr.h"
#include "wchar.h"
#include "wrapped.h"

using namespace irr;

SCM
IGUIListBox_addItem (SCM gui_listbox,
                     SCM text,
                     SCM icon)
{
  gui::IGUIListBox* listbox = (gui::IGUIListBox*)scm_to_irr_pointer (gui_listbox);
  u32 item_id;
  if (icon == SCM_UNDEFINED)
    {
      item_id = listbox->addItem (scm_to_wide_char_string (text));
    }
  else
    {
      item_id = listbox->addItem (scm_to_wide_char_string (text),
                                  scm_to_int32 (icon));
    }
  return scm_from_uint32 (item_id);
}

void
init_gui_listbox (void)
{
  DEFINE_GSUBR ("IGUIListBox_addItem", 2, 1, 0, IGUIListBox_addItem);
}
