/* guile-irrlicht --- GNU Guile bindings for Irrlicht Engine

   Copyright (C) 2020 Javier Sancho <jsf@jsancho.org>

   This file is part of guile-irrlicht.

   guile-irrlicht is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 3 of the
   License, or (at your option) any later version.

   guile-irrlicht is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with guile-irrlicht. If not, see
   <http://www.gnu.org/licenses/>.
*/

#include <irrlicht/irrlicht.h>
#include <libguile.h>
#include "vector3d.h"

using namespace irr;

SCM
scm_from_vector3df (core::vector3df vector3d)
{
  return scm_list_3 (scm_from_double (vector3d.X),
                     scm_from_double (vector3d.Y),
                     scm_from_double (vector3d.Z));
}

core::vector3df
scm_to_vector3df (SCM vector3d)
{
  return core::vector3df
    (scm_to_double (scm_car (vector3d)),
     scm_to_double (scm_cadr (vector3d)),
     scm_to_double (scm_caddr (vector3d)));
}
